package com.ejie.ab79.control.tablet;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.SessionAttributes;

import com.ejie.ab79.clientesWS.ab61WebService.Ab61Exception;
import com.ejie.ab79.clientesWS.ab61WebService.DocumentoExpediente;
import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.comun.UtilDate;
import com.ejie.ab79.model.DocumentosDescargar;
import com.ejie.ab79.model.DocumentosSubidos;
import com.ejie.ab79.model.DocumentosTablet;
import com.ejie.ab79.model.VReateDocumentos;
import com.ejie.ab79.model.expedientes.DatosTerceros;
import com.ejie.ab79.model.expedientes.Expedientes;
import com.ejie.ab79.service.DocumentoExpedienteService;
import com.ejie.ab79.service.DocumentosDescargarService;
import com.ejie.ab79.service.DocumentosSubidosService;
import com.ejie.ab79.service.VReateDocumentosService;
import com.ejie.ab79.service.expedientes.DatosTercerosService;
import com.ejie.ab79.service.expedientes.ExpedientesService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;

/**
 * PlantillasController  
 * 
 *  
 */
@SessionAttributes("usuario")
@Controller
@RequestMapping(value = "/tablet")

public class TabletController {

	private static final Logger logger = LoggerFactory.getLogger(TabletController.class);

	@Autowired
	private DocumentosSubidosService documentosSubidosService;
	@Autowired
	private ExpedientesService expedientesService;
	@Autowired
	private DatosTercerosService datosTercerosService;
	@Autowired
	private VReateDocumentosService vReateDocumentosService;
	@Autowired
	private DocumentoExpedienteService documentoExpedienteService;
	@Autowired
	private DocumentosDescargarService documentosDescargarService;

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getModal() {
		TabletController.logger.info("[GET - View] : tablet");
		return "tablet";
	}

	@RequestMapping(value = "/documentacionInspeccion/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<DocumentosSubidos> filterDocumentacionInspeccion(
			@RequestJsonBody(param = "filter") DocumentosSubidos filterDocumentosSubidos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		TabletController.logger.info("[POST - filter] : Obtener Documentacion de la inspeccion");
		return this.documentosSubidosService.filterDocumentacionInspeccion(filterDocumentosSubidos, tableRequestDto,
				false);
	}

	@RequestMapping(value = "/documentoExpediente/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<DocumentoExpediente> filterDocumentoExpediente(
			@RequestJsonBody(param = "filter") DocumentoExpediente filterDocumentoExpediente,
			@RequestJsonBody TableRequestDto tableRequestDto) throws Ab61Exception {

		return this.documentoExpedienteService.filterDocumentoExpediente(filterDocumentoExpediente, tableRequestDto,
				false);
	}

	@RequestMapping(value = "/documentacionActividad/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<VReateDocumentos> filterDocumentacionActividad(
			@RequestJsonBody(param = "filter") VReateDocumentos filterVReateDocumentos,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		return this.vReateDocumentosService.filterDocumentacionActividad(filterVReateDocumentos, tableRequestDto,
				false);
	}

	@RequestMapping(value = "/documentacionExpRel/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Expedientes> filterDocumentacionExpRel(
			@RequestJsonBody(param = "filter") Expedientes filterExpedientes,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		TabletController.logger.info("[POST - filter] : Obtener Documentacion de los expedientes relacionados");

		List<DatosTerceros> listaTitulares = this.datosTercerosService
				.findTitularExpediente(filterExpedientes.getIdExpediente());

		String documentosTitular = "";

		for (DatosTerceros titular : listaTitulares) {
			if (titular.getDocumento() != null) {
				documentosTitular += "\'" + titular.getDocumento() + "\', ";
			}
		}

		if (documentosTitular.length() > 0) {
			documentosTitular = documentosTitular.substring(0, documentosTitular.length() - 2);
		}

		return this.expedientesService.filterDocumentacionExpRel(filterExpedientes, tableRequestDto, documentosTitular);
	}

	@RequestMapping(value = "/resumen/{idInspeccion}", method = RequestMethod.POST)
	public @ResponseBody List<DocumentosDescargar> resumenFilter(@PathVariable int idInspeccion,
			@RequestBody DocumentosTablet documentosTablet, @ModelAttribute("usuario") Usuario usuario)
			throws ParseException {

		return this.documentosDescargarService.rellenarDocumentosDescargar(idInspeccion, documentosTablet, usuario);
	}

	@RequestMapping(value = "/guardar/{idInspeccion}", method = RequestMethod.POST)
	public @ResponseBody List<DocumentosDescargar> guardarTablet(@PathVariable int idInspeccion,
			@RequestBody DocumentosTablet documentosTablet, @ModelAttribute("usuario") Usuario usuario)
			throws ParseException {

		return this.documentosDescargarService.guardarDocumentos(idInspeccion, documentosTablet, usuario);
	}

	@RequestMapping(value = "/obtenerEnviados/{idInspeccion}/{origenDocumentacion}", method = RequestMethod.GET)
	public @ResponseBody List<String> obtenerEnviados(@PathVariable Integer idInspeccion,
			@PathVariable Integer origenDocumentacion) {

		List<String> listaOids = new ArrayList<String>();
		List<DocumentosDescargar> listaDocumentosDescargar = this.documentosDescargarService
				.obtenerEnviados(idInspeccion, origenDocumentacion);

		for (DocumentosDescargar documentoDescargar : listaDocumentosDescargar) {
			listaOids.add(documentoDescargar.getOid());
		}

		return listaOids;
	}

	@RequestMapping(value = "/obtenerEnviadosExpRel/{idInspeccion}", method = RequestMethod.GET)
	public @ResponseBody List<DocumentoExpediente> obtenerEnviadosExpRel(@PathVariable Integer idInspeccion) {

		List<DocumentoExpediente> listaDocuemntacionExpediente = new ArrayList<DocumentoExpediente>();
		List<DocumentosDescargar> listaDocumentosDescargar = this.documentosDescargarService
				.obtenerEnviadosExpRel(idInspeccion);

		for (DocumentosDescargar documentoDescargar : listaDocumentosDescargar) {
			DocumentoExpediente documentoExpediente = new DocumentoExpediente();
			documentoExpediente.setNombreDocumento(documentoDescargar.getNombreDocumento());
			documentoExpediente.setTipoDocumento(documentoDescargar.getDescripcionTipoCastellano());
			documentoExpediente.setTituloDocumento(documentoDescargar.getTituloDocumento());
			String fechaSubidaStr = UtilDate.convertirEnFechaConHora(documentoDescargar.getFechaAportado());
			documentoExpediente.setFechaSubidaStr(fechaSubidaStr);
			documentoExpediente.setOidDokusi(documentoDescargar.getOid());
			documentoExpediente.setFolderNumber(documentoDescargar.getFolderNumber());

			listaDocuemntacionExpediente.add(documentoExpediente);
		}

		return listaDocuemntacionExpediente;
	}

}
